import { SubscribeCallback, Resource, CacheStoreConfig, CacheStoreData } from '@rest-api-handler/core';
import { ActionWithPayload } from './utils/actionTypes';
import { EnhancedStore } from './restStoreEnhancer.types';
export declare function createConnectedStore<ResourceType extends Resource>(storeName: string, { initialData, partialUpdate }: CacheStoreConfig<ResourceType>): {
    getState: () => any;
    dispatch: (action: ActionWithPayload<any, any>) => void;
    subscribe: (callback: SubscribeCallback<ResourceType>) => string;
    unsubscribe: (id: string) => boolean;
    actions: {
        update: {
            request: (data: {
                routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                id: string | number;
            }) => {
                type: string;
                payload: {
                    routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                    id: string | number;
                };
            };
            success: (data: {
                routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                id: string | number;
                data: any;
            }) => {
                type: string;
                payload: {
                    routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                    id: string | number;
                    data: any;
                };
            };
            failure: (data: {
                routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                error: Error;
                id?: string | number | undefined;
            }) => {
                type: string;
                payload: {
                    routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                    error: Error;
                    id?: string | number | undefined;
                };
            };
            cancel: (data: {
                routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
            }) => {
                type: string;
                payload: {
                    routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                };
            };
        };
        updateList: {
            request: (data: {
                routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
            }) => {
                type: string;
                payload: {
                    routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                };
            };
            success: (data: {
                routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                data: Record<string, any>;
            }) => {
                type: string;
                payload: {
                    routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                    data: Record<string, any>;
                };
            };
            failure: (data: {
                routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                error: Error;
            }) => {
                type: string;
                payload: {
                    routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                    error: Error;
                };
            };
            cancel: (data: {
                routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
            }) => {
                type: string;
                payload: {
                    routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                };
            };
        };
        deleteResource: (data: {
            routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
            id: string | number;
        }) => {
            type: string;
            payload: {
                routeData?: import("@rest-api-handler/core").RouteDataWithName | undefined;
                id: string | number;
            };
        };
        clearStore: () => {
            type: string;
        };
    };
    reducer: (state: CacheStoreData<ResourceType> | undefined, action: import("@rest-api-handler/core/dist/utils/actionTypes").ActionWithPayload<any, any>) => CacheStoreData<ResourceType>;
    getStoreName: () => string;
    injectReduxStore: (store: EnhancedStore<any>) => void;
    clearStore: () => void;
};
