var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { combineReducers, } from 'redux';
import { emitWarning, WarningCodes } from './warning.service';
import { REST_API_STORE_ID } from './restStoreEnhancer.types';
import { isEmpty } from './utils/objects';
function generateReducers(restResources) {
    var restResourcesReducers = {};
    Object.keys(restResources).map(function (resourceKey) {
        var _a = restResources[resourceKey], storeId = _a.storeId, reducer = _a.reducer;
        if (resourceKey !== storeId) {
            emitWarning(storeId, WarningCodes.keyMismatch, resourceKey, storeId);
        }
        restResourcesReducers[storeId] = reducer;
    });
    return combineReducers(restResourcesReducers);
}
function injectReduxToResources(store, restResources) {
    Object.keys(restResources).map(function (resourceKey) {
        var injectReduxStore = restResources[resourceKey].injectReduxStore;
        injectReduxStore(store);
    });
}
export var connectToRestResources = function (restResources) {
    if (restResources === void 0) { restResources = {}; }
    return function (createStore) { return function (reducer, preloadedState) {
        var _a;
        if (preloadedState === void 0) { preloadedState = {}; }
        if (isEmpty(restResources)) {
            emitWarning('', WarningCodes.noResources);
        }
        var entitiesReducer = generateReducers(restResources);
        function enhancedReducer(state, action) {
            var _a;
            var _b = REST_API_STORE_ID, restApiState = state[_b], otherState = __rest(state, [typeof _b === "symbol" ? _b : _b + ""]);
            return __assign(__assign({}, reducer(otherState, action)), (_a = {}, _a[REST_API_STORE_ID] = entitiesReducer((state ? state[REST_API_STORE_ID] : {}), action), _a));
        }
        var enhancedPreloadedState = __assign(__assign({}, preloadedState), (_a = {}, _a[REST_API_STORE_ID] = {}, _a));
        var store = createStore(enhancedReducer, enhancedPreloadedState);
        injectReduxToResources(store, restResources);
        return store;
    }; };
};
