/* eslint-disable no-console */
export var WarningCodes;
(function (WarningCodes) {
    WarningCodes["noResources"] = "no-resources";
    WarningCodes["keyMismatch"] = "key-mismatch";
    WarningCodes["storeNotSet"] = "store-not-set";
})(WarningCodes || (WarningCodes = {}));
// eslint-disable-next-line @typescript-eslint/no-unused-vars
export function emitWarning(storeName, code) {
    var data = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        data[_i - 2] = arguments[_i];
    }
    switch (code) {
        case WarningCodes.noResources:
            console.warn('[rest-api-handler]: Redux enhancer has no resources. Did you initialize the store?');
            break;
        case WarningCodes.keyMismatch:
            console.warn("[rest-api-handler]: Mismatch between store key " + data[0] + " and resourceName " + data[1] + ". store key will be ignored");
            break;
        case WarningCodes.storeNotSet:
            console.warn("[rest-api-handler]: Store " + storeName + " not set");
            break;
        // eslint-disable-next-line no-fallthrough
        default:
            console.warn("[rest-api-handler]: Unknown warning in store " + storeName);
    }
}
